import { NoSchemaIntrospectionCustomRule } from 'graphql';
export function useDisableIntrospection(props) {
    const store = new WeakMap();
    return {
        async onRequestParse({ request, serverContext }) {
            const isDisabled = props?.isDisabled ? await props.isDisabled(request, serverContext) : true;
            store.set(request, isDisabled);
        },
        onValidate({ addValidationRule, context }) {
            const isDisabled = store.get(context.request) ?? true;
            if (isDisabled) {
                addValidationRule(NoSchemaIntrospectionCustomRule);
            }
        },
    };
}
